class iaas::profile::horizon (

  $secret = undef,

  $endpoint_address = undef,
  $endpoint_servers = undef,

  $public_interface = undef,
  $admin_interface = undef,

) {
  class { '::horizon':
    allowed_hosts => '*',
    server_aliases => union([$endpoint_address, $::facts["ipaddress_${public_interface}"]], $endpoint_servers),
    secret_key => $secret,
    cache_server_ip => $::facts["ipaddress_${admin_interface}"],
    keystone_url => "http://${endpoint_address}:5000/v2.0",
    cinder_options => {
      'enable_backup' => true,
    },
    neutron_options => {
      'enable_lb' => true,
      'enable_firewall' => true,
      'enable_vpn' => true,
    },
  }

}
